VERSION 5.00
Begin VB.Form frmSearch 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Seacrh windows Registry"
   ClientHeight    =   4950
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   7440
   LinkTopic       =   "Form2"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4950
   ScaleWidth      =   7440
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame Frame1 
      Height          =   4455
      Left            =   120
      TabIndex        =   0
      Top             =   0
      Width           =   7215
      Begin VB.ListBox List1 
         Height          =   2010
         Left            =   240
         TabIndex        =   7
         Top             =   2160
         Width           =   6735
      End
      Begin VB.CheckBox Check1 
         Caption         =   "Match Case"
         Height          =   255
         Left            =   4920
         TabIndex        =   4
         Top             =   1680
         Width           =   1335
      End
      Begin VB.CommandButton Command2 
         Caption         =   "Close"
         Height          =   495
         Left            =   4920
         TabIndex        =   6
         Top             =   960
         Width           =   1935
      End
      Begin VB.CommandButton Command1 
         Caption         =   "Find Keys"
         Height          =   495
         Left            =   4920
         TabIndex        =   5
         Top             =   360
         Width           =   1935
      End
      Begin VB.TextBox Text1 
         Height          =   285
         Left            =   1680
         TabIndex        =   3
         Top             =   1320
         Width           =   2895
      End
      Begin VB.ComboBox Combo2 
         Height          =   315
         Left            =   1680
         Style           =   2  'Dropdown List
         TabIndex        =   2
         Top             =   840
         Width           =   2895
      End
      Begin VB.ComboBox Combo1 
         Height          =   315
         Left            =   1680
         Style           =   2  'Dropdown List
         TabIndex        =   1
         Top             =   360
         Width           =   2895
      End
      Begin VB.Label Label3 
         Caption         =   "Find What:"
         Height          =   255
         Left            =   240
         TabIndex        =   10
         Top             =   1320
         Width           =   1815
      End
      Begin VB.Label Label2 
         Caption         =   "Search Mode:"
         Height          =   375
         Left            =   240
         TabIndex        =   9
         Top             =   840
         Width           =   2055
      End
      Begin VB.Label Label1 
         Caption         =   "Search Branch:"
         Height          =   255
         Left            =   240
         TabIndex        =   8
         Top             =   360
         Width           =   2175
      End
   End
   Begin VB.Label Label4 
      Caption         =   "Based on suggestions given at Microsoft site"
      Height          =   375
      Left            =   120
      TabIndex        =   11
      Top             =   4560
      Width           =   7215
   End
End
Attribute VB_Name = "frmSearch"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'~~ this code is based on suggestioned at Microsoft site.
Option Explicit

Private Declare Function RegOpenKeyEx Lib "advapi32.dll" _
Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, _
ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long

Private Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" _
(ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, lpcbName As Long, _
ByVal lpReserved As Long, ByVal lpClass As String, lpcbClass As Long, _
lpftLastWriteTime As FILETIME) As Long

Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long

Const HKEY_CLASSES_ROOT = &H80000000
Const HKEY_CURRENT_USER = &H80000001
Const HKEY_LOCAL_MACHINE = &H80000002
Const HKEY_USERS = &H80000003

Const ERROR_SUCCESS = 0&

Const SYNCHRONIZE = &H100000
Const STANDARD_RIGHTS_READ = &H20000
Const KEY_QUERY_VALUE = &H1
Const KEY_ENUMERATE_SUB_KEYS = &H8
Const KEY_NOTIFY = &H10
Const KEY_READ = ((STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or _
KEY_NOTIFY) And (Not SYNCHRONIZE))

Private Type FILETIME
    intLow As Long
    intHigh As Long
End Type

Dim strBranch As Long

Private Sub Combo1_Click()
    '~~> Set the branch to search as per user choice
    Select Case Combo1.ListIndex
        Case 0
            strBranch = HKEY_CLASSES_ROOT
        Case 1
            strBranch = HKEY_CURRENT_USER
        Case 2
            strBranch = HKEY_LOCAL_MACHINE
        Case Else
            strBranch = HKEY_USERS
    End Select
End Sub

Private Sub Command1_Click()
    Dim i As Integer, lngKeyHandle As Long, lngResult As Long
    Dim lngCurIdx As Long, strValue As String, lngValueLen As Long
    Dim strClass As String, lngClassLen As Long, strResult As String
    Dim lngTime As FILETIME, strSearch As String, intSearchLen As Integer
    Dim blnMatch As Boolean
    
    i = 0
    
    '~~> Clear the current results
    List1.Clear
    
    '~~> Assign the new string to search for
    strSearch = Text1.Text
    intSearchLen = Len(strSearch)
    
    '~~> Open the Root Branch to search
    lngResult = RegOpenKeyEx(strBranch, "", 0&, KEY_READ, lngKeyHandle)
    
    If lngResult <> ERROR_SUCCESS Then
        MsgBox "Cannot open key.", , "Search Registry Keys"
    Else
    
    '~~> If the Root branch can be opened, disable
    '~~> the buttons and begin the search
        Command1.Enabled = False
        Command2.Enabled = False
        List1.Enabled = False
        Form1.MousePointer = 11
        
        lngCurIdx = 0
        Do
            lngValueLen = 2000
            strValue = String(lngValueLen, 0)
            lngClassLen = 2000
            strClass = String(lngClassLen, 0)
        
            '~~> Enumerate all the sub keys
            lngResult = RegEnumKeyEx(lngKeyHandle, _
                 lngCurIdx, _
                 ByVal strValue, _
                 lngValueLen, _
                 0&, _
                 ByVal strClass, _
                 lngClassLen, _
                 lngTime)
           
            '~~> Increment the index of found keys
            lngCurIdx = lngCurIdx + 1
        
            If lngResult = ERROR_SUCCESS Then
                '~~> Trim the current key to its actual length
                strResult = Left(strValue, lngValueLen)
                
                '~~> Eliminate case if the search is insensitive
                blnMatch = False
                strValue = strResult
                If Check1.Value = 0 Then
                    strResult = LCase(strResult)
                    strSearch = LCase(strSearch)
                End If

                '~~> Compare strings based upon search type
                Select Case Combo2.ListIndex
                    Case 0
                        '~~> Check if any portion of the search string is found.
                        If InStr(strResult, strSearch) Then blnMatch = True
                    Case 1
                        '~~> Check if an exact match is found.
                        If strResult = strSearch Then blnMatch = True
                    Case 2
                        '~~> Check if the search string matches the
                        '~~> left portion of the key string.
                        If Left(strResult, intSearchLen) = strSearch Then blnMatch = True
                    Case Else
                        '~~> Check if the search string matches the
                        '~~> right portion of the key string.
                        If Right(strResult, intSearchLen) = strSearch Then blnMatch = True
                End Select
                
                '~~> Populate the list with keys that match
                '~~> the search criteria
                If blnMatch Then
                    i = i + 1
                    List1.AddItem strValue
                End If
            End If
        
        '~~> Keep looking for more keys
        Loop While lngResult = ERROR_SUCCESS
        '~~> Close the Root Branch
        lngResult = RegCloseKey(lngKeyHandle)
    
        '~~> Enable the buttons
        Form1.MousePointer = 0
        List1.Enabled = True
        Command1.Enabled = True
        Command2.Enabled = True
        
        '~~> Display the total matches
        MsgBox "Total matches:" & Str(i), , "Search Registry Keys"
    End If
End Sub
Private Sub Command2_Click()
    Unload Me
End Sub

Private Sub Form_Load()
    Combo1.AddItem "HKEY_CLASSES_ROOT"
    Combo1.AddItem "HKEY_CURRENT_USER"
    Combo1.AddItem "HKEY_LOCAL_MACHINE"
    Combo1.AddItem "HKEY_USERS"
    Combo1.ListIndex = 0
    
    Combo2.AddItem "Portion"
    Combo2.AddItem "All"
    Combo2.AddItem "Left"
    Combo2.AddItem "Right"
    Combo2.ListIndex = 0
End Sub
